searchNodes=[{"doc":"Manage translations embedded into structs. Although it can be used with any struct Trans shines when paired with an Ecto.Schema . It allows you to keep the translations into a field of the schema and avoids requiring extra tables for translation storage and complex joins when retrieving translations from the database. Trans is split into two main components: Trans.Translator - provides easy access to struct translations. Trans.QueryBuilder - provides helpers for querying translations using Ecto.Query (requires Ecto.SQL ). When used, Trans accepts the following options: :translates (required) - list of the fields that will be translated. :container (optional) - name of the field that contains the embedded translations. Defaults to :translations . :default_locale (optional) - declares the locale of the base untranslated column. Structured translations Structured translations are the preferred and recommended way of using Trans . To use structured translations you must define the translations as embedded schemas : defmodule MyApp.Article do use Ecto.Schema use Trans , translates : [ :title , :body ] , default_locale : :en schema &quot;articles&quot; do field :title , :string field :body , :string embeds_one :translations , Translations , on_replace : :update , primary_key : false do embeds_one :es , MyApp.Article.Translation embeds_one :fr , MyApp.Article.Translation end end end defmodule MyApp.Article.Translation do use Ecto.Schema @primary_key false embedded_schema do field :title , :string field :body , :string end end Although they required more code than free-form translations, structured translations provide some nice benefits that make them the preferred way of using Trans : High flexibility when making validations and transformation using the embedded schema's own changeset. Easy to integrate with HTML forms leveraging the capabilities of inputs_for Easy navegability using the dot notation. Free-form translations Free-form translations were the main way of using Trans until the 2.3.0 version. They are still supported for compatibility with older versions but not recommended for new projects. To use free-form translations you must define the translations as a map: defmodule MyApp.Article do use Ecto.Schema use Trans , translates : [ :title , :body ] , default_locale : :en schema &quot;articles&quot; do field :title , :string field :body , :string field :translations , :map end end Although they require less code, free-form translations provide much less guarantees : There is no way to tell what content and which form will be stored in the translations field. Hard to integrate with HTML forms since the Phoenix helpers are not available. Difficult navigation requiring the braces notation from the Access protocol. The translation container As we have seen in the previous examples, Trans automatically stores and looks for translations in a field called :translations . This is known as the translations container. In certain cases you may want to use a different field for storing the translations, this can be specified when using Trans in your module. # Use the field `:locales` as translation container instead of the default `:translations` use Trans , translates : [ ... ] , container : :locales Reflection Any module that uses Trans will have an autogenerated __trans__ function that can be used for runtime introspection of the translation metadata. __trans__(:fields) - Returns the list of translatable fields. __trans__(:container) - Returns the name of the translation container. __trans__(:default_locale) - Returns the name of default locale.","ref":"Cldr.Trans.html","title":"Cldr.Trans","type":"module"},{"doc":"Checks whether the given field is translatable or not. Returns true if the given field is translatable. Raises if the given module or struct does not use Trans . Examples Assuming the Article schema defined in Structured translations . If we want to know whether a certain field is translatable or not we can use this function as follows (we can also pass a struct instead of the module name itself): iex&gt; Trans . translatable? ( Article , :title ) true May be also used with translatable structs: iex&gt; article = % Article { } iex&gt; Trans . translatable? ( article , :not_existing ) false Raises if the given module or struct does not use Trans : iex&gt; Trans . translatable? ( Date , :day ) ** (RuntimeError) Elixir.Date must use `Trans` in order to be translated","ref":"Cldr.Trans.html#translatable?/2","title":"Cldr.Trans.translatable?/2","type":"function"},{"doc":"","ref":"Cldr.Trans.html#translations/3","title":"Cldr.Trans.translations/3","type":"macro"},{"doc":"","ref":"Cldr.Trans.html#translations/4","title":"Cldr.Trans.translations/4","type":"macro"},{"doc":"A struct field as an atom","ref":"Cldr.Trans.html#t:field/0","title":"Cldr.Trans.field/0","type":"type"},{"doc":"When translating or querying either a single locale or a list of locales can be provided","ref":"Cldr.Trans.html#t:locale_list/0","title":"Cldr.Trans.locale_list/0","type":"type"},{"doc":"A translatable struct that uses Trans","ref":"Cldr.Trans.html#t:translatable/0","title":"Cldr.Trans.translatable/0","type":"type"},{"doc":"Provides helpers for filtering translations in Ecto.Queries . This module requires Ecto.SQL to be available during the compilation.","ref":"Cldr.Trans.QueryBuilder.html","title":"Cldr.Trans.QueryBuilder","type":"module"},{"doc":"","ref":"Cldr.Trans.QueryBuilder.html#translated/2","title":"Cldr.Trans.QueryBuilder.translated/2","type":"macro"},{"doc":"Generates a SQL fragment for accessing a translated field in an Ecto.Query . The generated SQL fragment can be coupled with the rest of the functions and operators provided by Ecto.Query and Ecto.Query.API . Safety This macro will emit errors when used with untranslatable schema modules or fields. Errors are emitted during the compilation phase thus avoiding runtime errors after the queries are built. Examples Assuming the Article schema defined in Structured translations : # Return all articles that have a Spanish translation from a in Article , where : not is_nil ( translated ( Article , a , :es ) ) ) #=&gt; SELECT a0.&quot;id&quot;, a0.&quot;title&quot;, a0.&quot;body&quot;, a0.&quot;translations&quot; #=&gt; FROM &quot;articles&quot; AS a0 #=&gt; WHERE (NOT (NULLIF((a0.&quot;translations&quot;-&gt;&#39;es&#39;),&#39;null&#39;) IS NULL)) # Query items with a certain translated value from a in Article , where : translated ( Article , a . title , :fr ) == &quot;Elixir&quot; #=&gt; SELECT a0.&quot;id&quot;, a0.&quot;title&quot;, a0.&quot;body&quot;, a0.&quot;translations&quot; #=&gt; FROM &quot;articles&quot; AS a0 #=&gt; WHERE (COALESCE(a0.&quot;translations&quot;-&gt;$1-&gt;&gt;$2, a0.&quot;title&quot;) = &#39;Elixir&#39;) # Query items with a translated value in the current locale from a in Article , where : translated ( Article , a . title ) == &quot;Elixir&quot; ) #=&gt; SELECT a0.&quot;id&quot;, a0.&quot;title&quot;, a0.&quot;body&quot;, a0.&quot;translations&quot; #=&gt; FROM &quot;articles&quot; AS a0 #=&gt; WHERE (translate_field(a0, $1::varchar, $2::varchar, $3::varchar, $4::varchar[]) = &#39;Elixir&#39;) # Here the parameters are the following when the current locale is &quot;en&quot;: # [&quot;translations&quot;, &quot;title&quot;, &quot;en&quot;, [&quot;en-001&quot;, &quot;en&quot;]] # Query items using a case insensitive comparison from a in Article , where : ilike ( translated ( Article , a . body , :es ) , &quot;%elixir%&quot; ) #=&gt; SELECT a0.&quot;id&quot;, a0.&quot;title&quot;, a0.&quot;body&quot;, a0.&quot;translations&quot; #=&gt; FROM &quot;articles&quot; AS a0 #=&gt; WHERE (COALESCE(a0.&quot;translations&quot;-&gt;$1-&gt;&gt;$2, a0.&quot;body&quot;) ILIKE &#39;%elixir%&#39;) Structured translations vs free-form translations The Cldr.Trans.QueryBuilder works with both Structured translations and with Free-form translations . In most situations, the queries can be performed in the same way for both cases. When querying for data translated into a certain locale we must know whether we are using structured or free-form translations . When using structured translations, the translations are saved as an embedded schema. This means that the locale keys will be always present even if there is no translation for that locale. In the database we have a NULL value ( nil in Elixir). # If MyApp.Article uses structured translations from a in Cldr.Trans.Article , where : not is_nil ( translated ( Cldr.Trans.Article , a , :es ) ) ) #=&gt; SELECT a0.&quot;id&quot;, a0.&quot;title&quot;, a0.&quot;body&quot;, a0.&quot;translations&quot; #=&gt; FROM &quot;articles&quot; AS a0 #=&gt; WHERE (NOT (NULLIF((a0.&quot;translations&quot;-&gt;&#39;es&#39;),&#39;null&#39;) IS NULL)) More complex queries The translated/3 macro can also be used with relations and joined schemas. For more complex examples take a look at the QueryBuilder tests (the file is located in test/trans/query_builder_test.ex ).","ref":"Cldr.Trans.QueryBuilder.html#translated/3","title":"Cldr.Trans.QueryBuilder.translated/3","type":"macro"},{"doc":"","ref":"Cldr.Trans.QueryBuilder.html#translated_as/2","title":"Cldr.Trans.QueryBuilder.translated_as/2","type":"macro"},{"doc":"Generates a SQL fragment for accessing a translated field in an Ecto.Query select clause and returning it aliased to the original field name. Therefore, this macro returns a translated field with the name of the table's base column name which means Ecto can load it into a struct without further processing or conversion. This macro delegates to the macro translated/3 and wraps the result in a fragment with the column alias. See Cldr.Trans.QueryBuilder.translated/3 for more information.","ref":"Cldr.Trans.QueryBuilder.html#translated_as/3","title":"Cldr.Trans.QueryBuilder.translated_as/3","type":"macro"},{"doc":"Provides easy access to struct translations. Although translations are stored in regular fields of an struct and can be accessed directly, it is recommended to access translations using the functions provided by this module instead. This functions present additional behaviours such as: Checking that the given struct uses Cldr.Trans Automatically inferring the translation container when needed. Falling back along a locale fallback chain (list of locales in which to look for a translation). If not found, then return the default value or raise and exception if a translation does not exist. Translating entire structs. All examples in this module assume the following article, based on the schema defined in Structured translations article = % MyApp.Article { title : &quot;How to Write a Spelling Corrector&quot; , body : &quot;A wonderful article by Peter Norvig&quot; , translations : % MyApp.Article.Translations { es : % MyApp.Article.Translation { title : &quot;Cómo escribir un corrector ortográfico&quot; , body : &quot;Un artículo maravilloso de Peter Norvig&quot; } , fr : % MyApp.Article.Translation { title : &quot;Comment écrire un correcteur orthographique&quot; , body : &quot;Un merveilleux article de Peter Norvig&quot; } } }","ref":"Cldr.Trans.Translator.html","title":"Cldr.Trans.Translator","type":"module"},{"doc":"Translate a single field into the given locale or raise if there is no translation. Just like translate/3 gets a translated field into the given locale. Raises if there is no translation available. Examples Assuming the example article in this module: Cldr.Trans.Translator . translate! ( article , :title , :de ) ** (RuntimeError) translation doesn&#39;t exist for field &#39;:title&#39; in locale &#39;de&#39;","ref":"Cldr.Trans.Translator.html#translate!/3","title":"Cldr.Trans.Translator.translate!/3","type":"function"},{"doc":"Translate a whole struct into the given locale. Translates the whole struct with all translatable values and translatable associations into the given locale. Similar to translate/3 but returns the whole struct. Examples Assuming the example article in this module, we can translate the entire struct into Spanish: # Translate the entire article into Spanish article_es = Trans.Translator . translate ( article , :es ) article_es . title #=&gt; &quot;Cómo escribir un corrector ortográfico&quot; article_es . body #=&gt; &quot;Un artículo maravilloso de Peter Norvig&quot; Just like translate/3 , falls back to the default locale if the translation does not exist: # The Deutsch translation does not exist so the default values are returned article_de = Trans.Translator . translate ( article , :de ) article_de . title #=&gt; &quot;How to Write a Spelling Corrector&quot; article_de . body #=&gt; &quot;A wonderful article by Peter Norvig&quot; Rather than just one locale, a list of locales (a locale fallback chain) can also be used. In this case, translation tries each locale in the fallback chain in sequence until a translation is found. If none is found, the default value is returned. # The Deutsch translation does not exist but the Spanish one does article_de = Cldr.Trans.Translator . translate ( article , [ :de , :es ] ) article_de . title #=&gt; &quot;Cómo escribir un corrector ortográfico&quot; article_de . body #=&gt; &quot;Un artículo maravilloso de Peter Norvig&quot;","ref":"Cldr.Trans.Translator.html#translate/1","title":"Cldr.Trans.Translator.translate/1","type":"function"},{"doc":"Translate a single field into the given locale. Translates the field into the given locale or falls back to the default value if there is no translation available. Examples Assuming the example article in this module: # We can get the Spanish title: Cldr.Trans.Translator . translate ( article , :title , :es ) &quot;Cómo escribir un corrector ortográfico&quot; # If the requested locale is not available, the default value will be returned: Cldr.Trans.Translator . translate ( article , :title , :de ) &quot;How to Write a Spelling Corrector&quot; # A fallback chain can also be used: Cldr.Trans.Translator . translate ( article , :title , [ :de , :es ] ) &quot;Cómo escribir un corrector ortográfico&quot; # If we request a translation for an invalid field, we will receive an error: Cldr.Trans.Translator . translate ( article , :fake_attr , :es ) ** (RuntimeError) &#39;Article&#39; module must declare &#39;fake_attr&#39; as translatable","ref":"Cldr.Trans.Translator.html#translate/2","title":"Cldr.Trans.Translator.translate/2","type":"function"},{"doc":"","ref":"Cldr.Trans.Translator.html#translate/3","title":"Cldr.Trans.Translator.translate/3","type":"function"},{"doc":"Generates a migration to add a database function translate_field that uses the Cldr.Trans structured translation schema to resolve a translation for a field.","ref":"Mix.Tasks.Cldr.Trans.Gen.TranslateFunction.html","title":"Mix.Tasks.Cldr.Trans.Gen.TranslateFunction","type":"task"},{"doc":"","ref":"Mix.Tasks.Cldr.Trans.Gen.TranslateFunction.html#format_string!/1","title":"Mix.Tasks.Cldr.Trans.Gen.TranslateFunction.format_string!/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Cldr.Trans.Gen.TranslateFunction.html#migrations_path/1","title":"Mix.Tasks.Cldr.Trans.Gen.TranslateFunction.migrations_path/1","type":"function"},{"doc":"","ref":"readme.html","title":"Cldr Trans","type":"extras"},{"doc":"ex_cldr_trans is an ex_cldr -integrated fork of the excellent trans by @crbelaus . The enhancements in this library have been been submitted as a PR to trans . If the PR is accepted in the future then this library will revert to depending on it rather than maintaining a fork. Such a change will not affect the functionality or API in this library. The documentation in cldr_trans is edited from the original trans documentation. Introduction ex_cldr_trans provides a way to manage and query translations embedded into schemas and removes the necessity of maintaining extra tables only for translation storage. It is an addon library to ex_cldr . ex_cldr_trans is published on hex.pm and the documentation is also available online .","ref":"readme.html#attribution","title":"Cldr Trans - Attribution","type":"extras"},{"doc":"Having Ecto SQL and Postgrex in your application will allow you to use the Cldr.Trans.QueryBuilder component to generate database queries based on translated data. You can still use the Cldr.Trans.Translator component without those dependencies though. Ecto SQL 3.0 or higher PostgreSQL 9.4 or higher (since Cldr.Trans leverages the JSONB datatype)","ref":"readme.html#optional-requirements","title":"Cldr Trans - Optional Requirements","type":"extras"},{"doc":"The traditional approach to content internationalization consists on using an additional table for each translatable schema. This table works only as a storage for the original schema translations. For example, we may have a posts and a posts_translations tables. This approach has a few disadvantages: It complicates the database schema because it creates extra tables that are coupled to the &quot;main&quot; ones. It makes migrations and schemas more complicated, since we always have to keep the two tables in sync. It requires constant JOINs in order to filter or fetch records along with their translations. The approach used by Cldr.Trans is based on modern RDBMSs support for unstructured datatypes. Instead of storing the translations in a different table, each translatable schema has an extra column that contains all of its translations. This approach drastically reduces the number of required JOINs when filtering or fetching records. Cldr.Trans is lightweight and modularized. The Cldr.Trans module provides metadata that is used by the Cldr.Trans.Translator and Cldr.Trans.QueryBuilder modules, which implement the main functionality of this library.","ref":"readme.html#why-cldr-trans","title":"Cldr Trans - Why CLDR Trans?","type":"extras"},{"doc":"Imagine that we have an Article schema that we want to translate: defmodule MyApp.Article do use Ecto.Schema schema &quot;articles&quot; do field :title , :string field :body , :string end end Add a JSON column The first step would be to add a new JSON column to the table so we can store the translations in it. defmodule MyApp.Repo.Migrations.AddTranslationsToArticles do use Ecto.Migration def change do alter table ( :articles ) do add :translations , :map end end end Generate database function migration ex_cldr_trans defines a Postgres database function to support in-db field translation. A migration task is provided to generate the migration required to define this function. % MIX_ENV = test mix cldr . trans . gen . translate_function * creating priv / repo / migrations * creating priv / repo / migrations / 20220307212312 _trans_gen_translate_function . exs Run migrations Migrate the database to add the translations column and define the database function. % mix ecto . migrate Define a backend module The next step is to define an ex_cldr backend module that defines the configured locales and other information for supporting localised applications. For example: defmodule MyApp.Cldr do use Cldr , locales : [ &quot;en&quot; , &quot;de&quot; , &quot;ja&quot; , &quot;en-AU&quot; , &quot;th&quot; , &quot;ar&quot; , &quot;pl&quot; , &quot;doi&quot; , &quot;fr-CA&quot; , &quot;nb&quot; , &quot;no&quot; ] , providers : [ Cldr.Trans ] end Note that for existing backend modules the only required step is to add Cldr.Trans to the list of :providers . Add translations to schema Once we have the new database column and the backend module, we can update the Article schema to include the translations: defmodule MyApp.Article do use Ecto.Schema use MyApp.Cldr.Trans , translates : [ :title , :body ] schema &quot;articles&quot; do field :title , :string field :body , :string # use the &#39;translations&#39; macro to set up a map-field with a set of nested # structs to handle translation values for each configured locale and each # translatable field translations :translations end def changeset ( article , params \\\\ %{ } ) do article |&gt; cast ( params , [ :title , :body ] ) # use &#39;cast_embed&#39; to handle values for the &#39;translations&#39; map-field with # a nested changeset |&gt; cast_embed ( :translations , with : &amp; translations_changeset / 2 ) |&gt; validate_required ( [ :title , :body ] ) end defp translations_changeset ( translations , params ) do translations |&gt; cast ( params , [ ] ) # use &#39;cast_embed&#39; to handle values for translated fields for each of the # configured languages with a changeset defined by the &#39;translations&#39; macro # above |&gt; cast_embed ( :es ) |&gt; cast_embed ( :fr ) end end After doing this we can leverage the Cldr.Trans.Translator and Cldr.Trans.QueryBuilder modules to fetch and query translations from the database. The translation storage can be managed using normal Ecto.Changeset functions just like any other field. Leveraging changesets and the inputs_for helper, your HTML form for Article might look like: &lt; . form let = { f } for = { @changeset } phx - change = &quot;validate&quot; phx - submit = &quot;save&quot; &gt; &lt; % = label f , :title % &gt; &lt; % = text_input f , :title % &gt; &lt; % = error_tag f , :title % &gt; &lt; ! -- translations for &#39;title&#39; field -- &gt; &lt; % = inputs_for f , :translations , fn form_translations -&gt; % &gt; &lt; % = for locale &lt;- [ :es , :fr ] do % &gt; &lt; % = inputs_for form_translations , locale , fn form_locale -&gt; % &gt; &lt; div &gt; &lt; span &gt; &lt; % = &quot; \#{ locale } &quot; % &gt; &lt; / span &gt; &lt; % = text_input form_locale , :title , placeholder : Map . get ( @changeset . data , :title ) % &gt; &lt; / div &gt; &lt; % = error_tag form_locale , :title % &gt; &lt; % end % &gt; &lt; % = label f , :body % &gt; &lt; % = text_input f , :body % &gt; &lt; % = error_tag f , :body % &gt; &lt; ! -- translations for &#39;body&#39; field -- &gt; &lt; % = inputs_for f , :translations , fn form_translations -&gt; % &gt; &lt; % = for locale &lt;- [ :es , :fr ] do % &gt; &lt; % = inputs_for form_translations , locale , fn form_locale -&gt; % &gt; &lt; div &gt; &lt; span &gt; &lt; % = &quot; \#{ locale } &quot; % &gt; &lt; / span &gt; &lt; % = text_input form_locale , :body , placeholder : Map . get ( @changeset . data , :body ) % &gt; &lt; / div &gt; &lt; % = error_tag form_locale , :body % &gt; &lt; % end % &gt; &lt; % = submit &quot;Save&quot; % &gt; &lt; / . form &gt;","ref":"readme.html#quickstart","title":"Cldr Trans - Quickstart","type":"extras"},{"doc":"Copyright 2018-2020 Kip Cole Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http :// www . apache . org / licenses / LICENSE - 2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"License","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"This is the changelog for Cldr Trans version 1.0.0 released on March 27th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Publish official 1.0 release","ref":"changelog.html#cldr-trans-v1-0-0","title":"Changelog - Cldr Trans v1.0.0","type":"extras"},{"doc":"This is the changelog for Cldr Trans version 1.0.0-rc.0 released on March 8th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Initial release forked from trans with enhancements to integrate with ex_cldr . The primary differences from trans are: Infers configured locales from the CLDR backend module Uses the locale fallback chain to find a translation Executes in-database translations via a database function Returns NULL (not JSON 'Null') for all cases","ref":"changelog.html#cldr-trans-v1-0-0-rc-0","title":"Changelog - Cldr Trans v1.0.0-rc.0","type":"extras"}]